using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Bus_AssignedInfo
    /// </summary>
    public partial class T_Bus_AssignedInfo
    {
        public T_Bus_AssignedInfo()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_AssignedInfo");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_AssignedInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_AssignedInfo(");
            strSql.Append("F_WorkOrderId,F_MainDeptId,F_OtherDeptIds,F_AssignedOpinion,F_Remark,F_CreateUser,F_CreateTime,F_IsSure,F_State,F_SureTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_SureUser,F_FeedbackTime,F_LimitTime,F_IsOverdue,F_IsSatisfie,F_IsReload,F_ReloadUser,F_ReloadTime,F_File,F_IsNotice,F_NoticeUser,F_NoticeTime)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_MainDeptId,@F_OtherDeptIds,@F_AssignedOpinion,@F_Remark,@F_CreateUser,@F_CreateTime,@F_IsSure,@F_State,@F_SureTime,@F_IsDelete,@F_DeleteUser,@F_DeleteTime,@F_SureUser,@F_FeedbackTime,@F_LimitTime,@F_IsOverdue,@F_IsSatisfie,@F_IsReload,@F_ReloadUser,@F_ReloadTime,@F_File,@F_IsNotice,@F_NoticeUser,@F_NoticeTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_MainDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_OtherDeptIds", SqlDbType.VarChar,500),
                    new SqlParameter("@F_AssignedOpinion", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsSure", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_SureTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SureUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_FeedbackTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsOverdue", SqlDbType.Int,4),
                    new SqlParameter("@F_IsSatisfie", SqlDbType.Int,4),
                    new SqlParameter("@F_IsReload", SqlDbType.Int,4),
                    new SqlParameter("@F_ReloadUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ReloadTime", SqlDbType.DateTime),
                    new SqlParameter("@F_File", SqlDbType.VarChar,500),
                    new SqlParameter("@F_IsNotice", SqlDbType.Int,4),
                    new SqlParameter("@F_NoticeUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_NoticeTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_MainDeptId;
            parameters[2].Value = model.F_OtherDeptIds;
            parameters[3].Value = model.F_AssignedOpinion;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsSure;
            parameters[8].Value = model.F_State;
            parameters[9].Value = model.F_SureTime;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_DeleteUser;
            parameters[12].Value = model.F_DeleteTime;
            parameters[13].Value = model.F_SureUser;
            parameters[14].Value = model.F_FeedbackTime;
            parameters[15].Value = model.F_LimitTime;
            parameters[16].Value = model.F_IsOverdue;
            parameters[17].Value = model.F_IsSatisfie;
            parameters[18].Value = model.F_IsReload;
            parameters[19].Value = model.F_ReloadUser;
            parameters[20].Value = model.F_ReloadTime;
            parameters[21].Value = model.F_File;
            parameters[22].Value = model.F_IsNotice;
            parameters[23].Value = model.F_NoticeUser;
            parameters[24].Value = model.F_NoticeTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_AssignedInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_AssignedInfo set ");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_MainDeptId=@F_MainDeptId,");
            strSql.Append("F_OtherDeptIds=@F_OtherDeptIds,");
            strSql.Append("F_AssignedOpinion=@F_AssignedOpinion,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_IsSure=@F_IsSure,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_SureTime=@F_SureTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=@F_DeleteTime,");
            strSql.Append("F_SureUser=@F_SureUser,");
            strSql.Append("F_FeedbackTime=@F_FeedbackTime,");
            strSql.Append("F_LimitTime=@F_LimitTime,");
            strSql.Append("F_IsOverdue=@F_IsOverdue,");
            strSql.Append("F_IsSatisfie=@F_IsSatisfie,");
            strSql.Append("F_IsReload=@F_IsReload,");
            strSql.Append("F_ReloadUser=@F_ReloadUser,");
            strSql.Append("F_ReloadTime=@F_ReloadTime,");
            strSql.Append("F_File=@F_File,");
            strSql.Append("F_IsNotice=@F_IsNotice,");
            strSql.Append("F_NoticeUser=@F_NoticeUser,");
            strSql.Append("F_NoticeTime=@F_NoticeTime");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_MainDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_OtherDeptIds", SqlDbType.VarChar,500),
                    new SqlParameter("@F_AssignedOpinion", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsSure", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_SureTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SureUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_FeedbackTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsOverdue", SqlDbType.Int,4),
                    new SqlParameter("@F_IsSatisfie", SqlDbType.Int,4),
                    new SqlParameter("@F_IsReload", SqlDbType.Int,4),
                    new SqlParameter("@F_ReloadUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ReloadTime", SqlDbType.DateTime),
                    new SqlParameter("@F_File", SqlDbType.VarChar,500),
                    new SqlParameter("@F_IsNotice", SqlDbType.Int,4),
                    new SqlParameter("@F_NoticeUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_NoticeTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_MainDeptId;
            parameters[2].Value = model.F_OtherDeptIds;
            parameters[3].Value = model.F_AssignedOpinion;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsSure;
            parameters[8].Value = model.F_State;
            parameters[9].Value = model.F_SureTime;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_DeleteUser;
            parameters[12].Value = model.F_DeleteTime;
            parameters[13].Value = model.F_SureUser;
            parameters[14].Value = model.F_FeedbackTime;
            parameters[15].Value = model.F_LimitTime;
            parameters[16].Value = model.F_IsOverdue;
            parameters[17].Value = model.F_IsSatisfie;
            parameters[18].Value = model.F_IsReload;
            parameters[19].Value = model.F_ReloadUser;
            parameters[20].Value = model.F_ReloadTime;
            parameters[21].Value = model.F_File;
            parameters[22].Value = model.F_IsNotice;
            parameters[23].Value = model.F_NoticeUser;
            parameters[24].Value = model.F_NoticeTime;
            parameters[25].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_AssignedInfo ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_AssignedInfo ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
		/// 得到一个对象实体
		/// </summary>
		public CallCenterApi.Model.T_Bus_AssignedInfo GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_WorkOrderId,F_MainDeptId,F_OtherDeptIds,F_AssignedOpinion,F_Remark,F_CreateUser,F_CreateTime,F_IsSure,F_State,F_SureTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_SureUser,F_FeedbackTime,F_LimitTime,F_IsOverdue,F_IsSatisfie,F_IsReload,F_ReloadUser,F_ReloadTime,F_File,F_IsNotice,F_NoticeUser,F_NoticeTime from T_Bus_AssignedInfo ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Bus_AssignedInfo model = new CallCenterApi.Model.T_Bus_AssignedInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_AssignedInfo DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_AssignedInfo model = new CallCenterApi.Model.T_Bus_AssignedInfo();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_MainDeptId"] != null && row["F_MainDeptId"].ToString() != "")
                {
                    model.F_MainDeptId = int.Parse(row["F_MainDeptId"].ToString());
                }
                if (row["F_OtherDeptIds"] != null)
                {
                    model.F_OtherDeptIds = row["F_OtherDeptIds"].ToString();
                }
                if (row["F_AssignedOpinion"] != null)
                {
                    model.F_AssignedOpinion = row["F_AssignedOpinion"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsSure"] != null && row["F_IsSure"].ToString() != "")
                {
                    model.F_IsSure = int.Parse(row["F_IsSure"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_SureTime"] != null && row["F_SureTime"].ToString() != "")
                {
                    model.F_SureTime = DateTime.Parse(row["F_SureTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_DeleteUser"] != null)
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
                if (row["F_SureUser"] != null)
                {
                    model.F_SureUser = row["F_SureUser"].ToString();
                }
                if (row["F_FeedbackTime"] != null && row["F_FeedbackTime"].ToString() != "")
                {
                    model.F_FeedbackTime = DateTime.Parse(row["F_FeedbackTime"].ToString());
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = DateTime.Parse(row["F_LimitTime"].ToString());
                }
                if (row["F_IsOverdue"] != null && row["F_IsOverdue"].ToString() != "")
                {
                    model.F_IsOverdue = int.Parse(row["F_IsOverdue"].ToString());
                }
                if (row["F_IsSatisfie"] != null && row["F_IsSatisfie"].ToString() != "")
                {
                    model.F_IsSatisfie = int.Parse(row["F_IsSatisfie"].ToString());
                }
                if (row["F_IsReload"] != null && row["F_IsReload"].ToString() != "")
                {
                    model.F_IsReload = int.Parse(row["F_IsReload"].ToString());
                }
                if (row["F_ReloadUser"] != null)
                {
                    model.F_ReloadUser = row["F_ReloadUser"].ToString();
                }
                if (row["F_ReloadTime"] != null && row["F_ReloadTime"].ToString() != "")
                {
                    model.F_ReloadTime = DateTime.Parse(row["F_ReloadTime"].ToString());
                }
                if (row["F_File"] != null)
                {
                    model.F_File = row["F_File"].ToString();
                }
                if (row["F_IsNotice"] != null && row["F_IsNotice"].ToString() != "")
                {
                    model.F_IsNotice = int.Parse(row["F_IsNotice"].ToString());
                }
                if (row["F_NoticeUser"] != null)
                {
                    model.F_NoticeUser = row["F_NoticeUser"].ToString();
                }
                if (row["F_NoticeTime"] != null && row["F_NoticeTime"].ToString() != "")
                {
                    model.F_NoticeTime = DateTime.Parse(row["F_NoticeTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_WorkOrderId,F_MainDeptId,F_OtherDeptIds,F_AssignedOpinion,F_Remark,F_CreateUser,F_CreateTime,F_IsSure,F_State,F_SureTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_SureUser,F_FeedbackTime,F_LimitTime,F_IsOverdue,F_IsSatisfie,F_IsReload,F_ReloadUser,F_ReloadTime,F_File,F_IsNotice,F_NoticeUser,F_NoticeTime ");
            strSql.Append(" FROM T_Bus_AssignedInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
		/// 获得前几行数据
		/// </summary>
		public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_WorkOrderId,F_MainDeptId,F_OtherDeptIds,F_AssignedOpinion,F_Remark,F_CreateUser,F_CreateTime,F_IsSure,F_State,F_SureTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_SureUser,F_FeedbackTime,F_LimitTime,F_IsOverdue,F_IsSatisfie,F_IsReload,F_ReloadUser,F_ReloadTime,F_File,F_IsNotice,F_NoticeUser,F_NoticeTime ");
            strSql.Append(" FROM T_Bus_AssignedInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_AssignedInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_AssignedInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 根据工单编号得到一个最新对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_AssignedInfo GetNewModelByWorkOrderID(string F_WorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Bus_AssignedInfo ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_IsDelete=0 ");
            strSql.Append(" order by F_Id desc");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20)
            };
            parameters[0].Value = F_WorkOrderId;

            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]); ;
            }
            else
            {
                return null;
            }
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Bus_AssignedInfo";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

